# generated by datamodel-codegen:
#   filename:  https://demo.mediascout.ru/swagger/v1/swagger.json
#   timestamp: 2023-03-28T05:36:47+00:00

from __future__ import annotations

from datetime import date, datetime
from enum import Enum
from typing import Any, Dict, List, Optional

from pydantic import BaseModel, Extra


class AgenciesViewData(BaseModel):
    class Config:
        extra = Extra.forbid

    canCreateAgency: Optional[bool] = None
    canRegisterAgency: Optional[bool] = None


class AgencyGroupListItemDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    contract: Optional[str] = None
    name: Optional[str] = None
    createDt: Optional[datetime] = None
    changeDt: Optional[datetime] = None
    agenciesCount: Optional[int] = None


class AgencyGroupUserRole(Enum):
    AgencyGroupUser = 'AgencyGroupUser'
    AgencyGroupAdministrator = 'AgencyGroupAdministrator'


class AgencyGroupUsersViewData(BaseModel):
    class Config:
        extra = Extra.forbid

    canCreateUser: Optional[bool] = None
    canEditUser: Optional[bool] = None
    isAdmin: Optional[bool] = None


class AgencyGroupsViewData(BaseModel):
    class Config:
        extra = Extra.forbid

    canCreateAgencyGroups: Optional[bool] = None
    canEditAgencyGroups: Optional[bool] = None
    canModifyAgencyGroupAgencies: Optional[bool] = None
    canModifyAgencyGroupAdmins: Optional[bool] = None


class AgencyUserPermissionDto(BaseModel):
    class Config:
        extra = Extra.forbid

    agencyId: Optional[str] = None
    isAllowWrite: Optional[bool] = None
    isAllowRead: Optional[bool] = None
    agencyGroupId: Optional[str] = None
    agencyGroupName: Optional[str] = None
    agencyName: Optional[str] = None


class ClearInvoiceDataWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None


class ClientRelationshipType(Enum):
    DirectClient = 'DirectClient'
    InitialContractClient = 'InitialContractClient'


class ContractStatus(Enum):
    Created = 'Created'
    Active = 'Active'


class ContractSubjectTypeWebApi(Enum):
    Distribution = 'Distribution'
    OrgDistribution = 'OrgDistribution'
    Representation = 'Representation'
    Mediation = 'Mediation'
    Other = 'Other'


class ContractType(Enum):
    ServiceAgreement = 'ServiceAgreement'
    MediationContract = 'MediationContract'
    AdditionalAgreement = 'AdditionalAgreement'
    SelfPromotionContract = 'SelfPromotionContract'
    VirtualFinalContract = 'VirtualFinalContract'


class CounterpartyStatus(Enum):
    Created = 'Created'
    Active = 'Active'


class CounterpartyType(Enum):
    TopLevelAgency = 'TopLevelAgency'
    Client = 'Client'


class CreativeForm(Enum):
    Banner = 'Banner'
    Text = 'Text'
    TextGraphic = 'TextGraphic'
    Video = 'Video'
    Audio = 'Audio'
    AudioBroadcast = 'AudioBroadcast'
    VideoBroadcast = 'VideoBroadcast'
    Other = 'Other'


class CreativeMediaDataItemWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    fileName: Optional[str] = None
    fileContentBase64: Optional[str] = None
    srcUrl: Optional[str] = None
    description: Optional[str] = None
    isArchive: Optional[bool] = None


class CreativeMediaListItemDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    creativeId: Optional[str] = None
    mediaLocation: Optional[str] = None
    fileSize: Optional[int] = None
    textData: Optional[str] = None
    description: Optional[str] = None
    createDt: Optional[datetime] = None
    changeDt: Optional[datetime] = None
    previewUrl: Optional[str] = None


class CreativeStatus(Enum):
    Created = 'Created'
    Active = 'Active'


class CreativeTextDataItemWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    textData: Optional[str] = None


class CreativeType(Enum):
    CPM = 'CPM'
    CPC = 'CPC'
    CPA = 'CPA'
    Other = 'Other'


class CreativeWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    finalContractId: Optional[str] = None
    initialContractId: Optional[str] = None
    type: Optional[CreativeType] = None
    form: Optional[CreativeForm] = None
    advertiserUrl: Optional[str] = None
    advertiserUrls: Optional[List[str]] = None
    description: Optional[str] = None
    targetAudience: Optional[str] = None
    isNative: Optional[bool] = None
    isSocial: Optional[bool] = None
    okvedCodes: Optional[List[str]] = None
    mediaData: Optional[List[CreativeMediaDataItemWebApiDto]] = None
    textData: Optional[List[CreativeTextDataItemWebApiDto]] = None
    id: Optional[str] = None
    erid: Optional[str] = None
    status: Optional[CreativeStatus] = None


class DelayedCreativeMediaWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    srcUrl: Optional[str] = None
    fileName: Optional[str] = None
    mediaDownloadError: Optional[str] = None


class EditCreativeWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    creativeGroupId: Optional[str] = None
    creativeGroupName: Optional[str] = None
    advertiserUrls: Optional[List[str]] = None


class EntityIdWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None


class Filter(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    value: Optional[str] = None


class GetClientsWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    inn: Optional[str] = None
    status: Optional[CounterpartyStatus] = None


class GetCreativesBulkWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None


class GetCreativesWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    creativeId: Optional[str] = None
    erid: Optional[str] = None
    initialContractId: Optional[str] = None
    initialContractNumber: Optional[str] = None
    finalContractId: Optional[str] = None
    finalContractNumber: Optional[str] = None
    status: Optional[CreativeStatus] = None


class GetFinalContractsWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    finalContractId: Optional[str] = None
    clientId: Optional[str] = None
    status: Optional[ContractStatus] = None


class GetInitialContractsWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    initialContractId: Optional[str] = None
    finalContractId: Optional[str] = None
    contractorId: Optional[str] = None
    contractorInn: Optional[str] = None
    contractorName: Optional[str] = None
    clientId: Optional[str] = None
    clientInn: Optional[str] = None
    clientName: Optional[str] = None
    status: Optional[ContractStatus] = None


class GetOuterContractsWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    outerContractId: Optional[str] = None
    status: Optional[ContractStatus] = None
    contractorId: Optional[str] = None
    clientId: Optional[str] = None


class InvoiceInitialContractItemWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    initialContractId: Optional[str] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None


class InvoicePartyRole(Enum):
    Rr = 'Rr'
    Ors = 'Ors'
    Rd = 'Rd'
    Ra = 'Ra'


class InvoiceStatus(Enum):
    Creating = 'Creating'
    Created = 'Created'
    Deleted = 'Deleted'
    Registering = 'Registering'
    RegistrationRequired = 'RegistrationRequired'
    Active = 'Active'


class InvoiceSummaryDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    status: Optional[InvoiceStatus] = None
    amount: Optional[float] = None
    initialContractsCount: Optional[int] = None
    initialContractsAmount: Optional[float] = None
    creativesCount: Optional[int] = None
    platformsCount: Optional[int] = None
    impsFactCount: Optional[int] = None
    impsPlanCount: Optional[int] = None
    impsAmount: Optional[float] = None


class InvoiceSummaryWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    status: Optional[InvoiceStatus] = None
    amount: Optional[float] = None
    initialContractsCount: Optional[int] = None
    initialContractsAmount: Optional[float] = None
    creativesCount: Optional[int] = None
    platformsCount: Optional[int] = None
    impsFactCount: Optional[int] = None
    impsPlanCount: Optional[int] = None
    impsAmount: Optional[float] = None


class JToken(BaseModel):
    __root__: List


class LegalForm(Enum):
    JuridicalPerson = 'JuridicalPerson'
    IndividualEntrepreneur = 'IndividualEntrepreneur'
    PhysicalPerson = 'PhysicalPerson'
    InternationalJuridicalPerson = 'InternationalJuridicalPerson'
    InternationalPhysicalPerson = 'InternationalPhysicalPerson'


class MediationActionType(Enum):
    Contracting = 'Contracting'
    Distribution = 'Distribution'
    CommercialRepresentation = 'CommercialRepresentation'
    Other = 'Other'


class MediationContractSubjectType(Enum):
    Mediation = 'Mediation'
    Representation = 'Representation'
    Other = 'Other'


class NavigationParams(BaseModel):
    class Config:
        extra = Extra.forbid

    agencyGroupId: Optional[str] = None
    agencyId: Optional[str] = None
    clientId: Optional[str] = None
    finalContractId: Optional[str] = None
    initialContractId: Optional[str] = None
    outerContractId: Optional[str] = None
    promoContractId: Optional[str] = None
    creativeId: Optional[str] = None
    invoiceId: Optional[str] = None
    platformId: Optional[str] = None
    userId: Optional[int] = None
    pageNumber: Optional[int] = None
    pageSize: Optional[int] = None
    filter: Optional[List[Filter]] = None


class OuterContractWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    number: Optional[str] = None
    date: Optional[date] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    isAgentActingForPublisher: Optional[bool] = None
    type: Optional[ContractType] = None
    subjectType: Optional[ContractSubjectTypeWebApi] = None
    actionType: Optional[MediationActionType] = None
    parentMainContractId: Optional[str] = None
    contractorId: Optional[str] = None
    id: Optional[str] = None
    status: Optional[ContractStatus] = None


class PlatformType(Enum):
    Site = 'Site'
    Application = 'Application'
    InformationSystem = 'InformationSystem'


class SelfPromotionContractWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    number: Optional[str] = None
    date: Optional[date] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    isAgentActingForPublisher: Optional[bool] = None
    type: Optional[ContractType] = None
    subjectType: Optional[ContractSubjectTypeWebApi] = None
    actionType: Optional[MediationActionType] = None
    parentMainContractId: Optional[str] = None
    id: Optional[str] = None
    status: Optional[ContractStatus] = None


class ServiceAgreementSubjectType(Enum):
    Advertisement = 'Advertisement'
    DistributionOrganization = 'DistributionOrganization'
    Other = 'Other'


class Severity(Enum):
    Error = 'Error'
    Warning = 'Warning'
    Info = 'Info'


class UserBaseDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[int] = None
    login: Optional[str] = None
    email: Optional[str] = None
    phoneNumber: Optional[str] = None
    firstName: Optional[str] = None
    middleName: Optional[str] = None
    lastName: Optional[str] = None
    enabled: Optional[bool] = None
    createDt: Optional[datetime] = None
    updated: Optional[datetime] = None


class UserRole(Enum):
    Admin = 'Admin'
    Moderator = 'Moderator'
    Agency = 'Agency'
    Erir = 'Erir'


class ValidationFailure(BaseModel):
    class Config:
        extra = Extra.forbid

    propertyName: Optional[str] = None
    errorMessage: Optional[str] = None
    attemptedValue: Optional[Any] = None
    customState: Optional[Any] = None
    severity: Optional[Severity] = None
    errorCode: Optional[str] = None
    formattedMessagePlaceholderValues: Optional[Dict[str, Any]] = None


class AgencyCardDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    type: Optional[CounterpartyType] = None
    legalForm: Optional[LegalForm] = None
    name: Optional[str] = None
    status: Optional[CounterpartyStatus] = None
    inn: Optional[str] = None
    regNumber: Optional[str] = None
    oksmNumber: Optional[str] = None
    mobilePhone: Optional[str] = None
    epayNumber: Optional[str] = None
    createDt: Optional[datetime] = None
    changeDt: Optional[datetime] = None
    displayName: Optional[str] = None
    contract: Optional[str] = None
    user: Optional[UserBaseDto] = None
    isOrs: Optional[bool] = None
    isRr: Optional[bool] = None
    rsUrl: Optional[str] = None


class AgencyGroupUserCardDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[int] = None
    login: Optional[str] = None
    email: Optional[str] = None
    phoneNumber: Optional[str] = None
    firstName: Optional[str] = None
    middleName: Optional[str] = None
    lastName: Optional[str] = None
    enabled: Optional[bool] = None
    createDt: Optional[datetime] = None
    updated: Optional[datetime] = None
    role: Optional[AgencyGroupUserRole] = None
    agencies: Optional[List[AgencyCardDto]] = None
    adminAgencyGroups: Optional[List[AgencyGroupListItemDto]] = None
    userAgencyGroups: Optional[List[AgencyGroupListItemDto]] = None
    agencyPermissions: Optional[List[AgencyUserPermissionDto]] = None


class BadRequestWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    errorType: Optional[str] = None
    errorItems: Optional[List[ValidationFailure]] = None


class ClientCardDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    type: Optional[CounterpartyType] = None
    legalForm: Optional[LegalForm] = None
    name: Optional[str] = None
    status: Optional[CounterpartyStatus] = None
    inn: Optional[str] = None
    regNumber: Optional[str] = None
    oksmNumber: Optional[str] = None
    mobilePhone: Optional[str] = None
    epayNumber: Optional[str] = None
    createDt: Optional[datetime] = None
    changeDt: Optional[datetime] = None
    displayName: Optional[str] = None
    agencyId: Optional[str] = None


class ClientWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    createMode: Optional[ClientRelationshipType] = None
    legalForm: Optional[LegalForm] = None
    inn: Optional[str] = None
    name: Optional[str] = None
    mobilePhone: Optional[str] = None
    epayNumber: Optional[str] = None
    regNumber: Optional[str] = None
    oksmNumber: Optional[str] = None
    id: Optional[str] = None
    status: Optional[CounterpartyStatus] = None


class ContractCardDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    agencyId: Optional[str] = None
    clientId: Optional[str] = None
    type: Optional[ContractType] = None
    status: Optional[ContractStatus] = None
    number: Optional[str] = None
    date: Optional[date] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    isAgentActingForPublisher: Optional[bool] = None
    mediationContractSubjectType: Optional[MediationContractSubjectType] = None
    serviceAgreementSubjectType: Optional[ServiceAgreementSubjectType] = None
    otherSubjectValue: Optional[str] = None
    actionType: Optional[MediationActionType] = None
    otherActionValue: Optional[str] = None
    parentMainContractId: Optional[str] = None
    createDt: Optional[datetime] = None
    changeDt: Optional[datetime] = None
    parentMainContract: Optional[ContractCardDto] = None
    isAutoRegister: Optional[bool] = None


class CreateClientWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    createMode: Optional[ClientRelationshipType] = None
    legalForm: Optional[LegalForm] = None
    inn: Optional[str] = None
    name: Optional[str] = None
    mobilePhone: Optional[str] = None
    epayNumber: Optional[str] = None
    regNumber: Optional[str] = None
    oksmNumber: Optional[str] = None


class CreateCreativeWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    finalContractId: Optional[str] = None
    initialContractId: Optional[str] = None
    type: Optional[CreativeType] = None
    form: Optional[CreativeForm] = None
    advertiserUrl: Optional[str] = None
    advertiserUrls: Optional[List[str]] = None
    description: Optional[str] = None
    targetAudience: Optional[str] = None
    isNative: Optional[bool] = None
    isSocial: Optional[bool] = None
    okvedCodes: Optional[List[str]] = None
    mediaData: Optional[List[CreativeMediaDataItemWebApiDto]] = None
    textData: Optional[List[CreativeTextDataItemWebApiDto]] = None


class CreateDelayedCreativeWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    finalContractId: Optional[str] = None
    initialContractId: Optional[str] = None
    type: Optional[CreativeType] = None
    form: Optional[CreativeForm] = None
    advertiserUrl: Optional[str] = None
    advertiserUrls: Optional[List[str]] = None
    description: Optional[str] = None
    targetAudience: Optional[str] = None
    isNative: Optional[bool] = None
    isSocial: Optional[bool] = None
    okvedCodes: Optional[List[str]] = None
    mediaData: Optional[List[CreativeMediaDataItemWebApiDto]] = None
    textData: Optional[List[CreativeTextDataItemWebApiDto]] = None
    userData: Optional[JToken] = None


class CreateFinalContractWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    number: Optional[str] = None
    date: Optional[date] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    isAgentActingForPublisher: Optional[bool] = None
    type: Optional[ContractType] = None
    subjectType: Optional[ContractSubjectTypeWebApi] = None
    actionType: Optional[MediationActionType] = None
    parentMainContractId: Optional[str] = None
    clientId: Optional[str] = None


class CreateInitialContractWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    number: Optional[str] = None
    date: Optional[date] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    isAgentActingForPublisher: Optional[bool] = None
    type: Optional[ContractType] = None
    subjectType: Optional[ContractSubjectTypeWebApi] = None
    actionType: Optional[MediationActionType] = None
    parentMainContractId: Optional[str] = None
    contractorId: Optional[str] = None
    clientId: Optional[str] = None
    finalContractId: Optional[str] = None


class CreateOuterContractWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    number: Optional[str] = None
    date: Optional[date] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    isAgentActingForPublisher: Optional[bool] = None
    type: Optional[ContractType] = None
    subjectType: Optional[ContractSubjectTypeWebApi] = None
    actionType: Optional[MediationActionType] = None
    parentMainContractId: Optional[str] = None
    contractorId: Optional[str] = None


class CreatePlatformWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    name: Optional[str] = None
    type: Optional[PlatformType] = None
    url: Optional[str] = None
    isOwner: Optional[bool] = None


class CreativeCardView(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    creativeGroupId: Optional[str] = None
    initialContractId: Optional[str] = None
    initialAgencyId: Optional[str] = None
    initialClientId: Optional[str] = None
    finalContractId: Optional[str] = None
    finalAgencyId: Optional[str] = None
    finalClientId: Optional[str] = None
    erid: Optional[str] = None
    status: Optional[CreativeStatus] = None
    type: Optional[CreativeType] = None
    form: Optional[CreativeForm] = None
    isSocial: Optional[bool] = None
    isNative: Optional[bool] = None
    targetAudience: Optional[str] = None
    description: Optional[str] = None
    creativeMedias: Optional[List[CreativeMediaListItemDto]] = None
    okvedCodes: Optional[List[str]] = None
    advertiserUrls: Optional[List[str]] = None
    createDt: Optional[datetime] = None
    changeDt: Optional[datetime] = None


class Crumbs(BaseModel):
    class Config:
        extra = Extra.forbid

    title: Optional[str] = None
    controller: Optional[str] = None
    action: Optional[str] = None
    route: Optional[str] = None
    navigation: Optional[NavigationParams] = None
    hasLink: Optional[bool] = None


class DelayedCreativeWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    creativeId: Optional[str] = None
    creativesDto: Optional[CreateDelayedCreativeWebApiDto] = None
    status: Optional[str] = None
    creativeCreatingErrors: Optional[List[str]] = None
    creativeMedias: Optional[List[DelayedCreativeMediaWebApiDto]] = None


class EditFinalContractWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    number: Optional[str] = None
    date: Optional[date] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    isAgentActingForPublisher: Optional[bool] = None
    type: Optional[ContractType] = None
    subjectType: Optional[ContractSubjectTypeWebApi] = None
    actionType: Optional[MediationActionType] = None
    parentMainContractId: Optional[str] = None
    clientId: Optional[str] = None
    id: Optional[str] = None


class EditInitialContractWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    number: Optional[str] = None
    date: Optional[date] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    isAgentActingForPublisher: Optional[bool] = None
    type: Optional[ContractType] = None
    subjectType: Optional[ContractSubjectTypeWebApi] = None
    actionType: Optional[MediationActionType] = None
    parentMainContractId: Optional[str] = None
    contractorId: Optional[str] = None
    clientId: Optional[str] = None
    finalContractId: Optional[str] = None
    id: Optional[str] = None


class EditInvoiceDataWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    number: Optional[str] = None
    date: Optional[date] = None
    contractorRole: Optional[InvoicePartyRole] = None
    clientRole: Optional[InvoicePartyRole] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    startDate: Optional[date] = None
    endDate: Optional[date] = None
    finalContractId: Optional[str] = None


class EditOuterContractWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    number: Optional[str] = None
    date: Optional[date] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    isAgentActingForPublisher: Optional[bool] = None
    type: Optional[ContractType] = None
    subjectType: Optional[ContractSubjectTypeWebApi] = None
    actionType: Optional[MediationActionType] = None
    parentMainContractId: Optional[str] = None
    contractorId: Optional[str] = None
    id: Optional[str] = None


class EditPlatformWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    name: Optional[str] = None
    type: Optional[PlatformType] = None
    url: Optional[str] = None
    isOwner: Optional[bool] = None
    id: Optional[str] = None


class FinalContractCardDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    agencyId: Optional[str] = None
    clientId: Optional[str] = None
    type: Optional[ContractType] = None
    status: Optional[ContractStatus] = None
    number: Optional[str] = None
    date: Optional[date] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    isAgentActingForPublisher: Optional[bool] = None
    mediationContractSubjectType: Optional[MediationContractSubjectType] = None
    serviceAgreementSubjectType: Optional[ServiceAgreementSubjectType] = None
    otherSubjectValue: Optional[str] = None
    actionType: Optional[MediationActionType] = None
    otherActionValue: Optional[str] = None
    parentMainContractId: Optional[str] = None
    createDt: Optional[datetime] = None
    changeDt: Optional[datetime] = None
    parentMainContract: Optional[ContractCardDto] = None
    isAutoRegister: Optional[bool] = None
    isRegReport: Optional[bool] = None


class FinalContractWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    number: Optional[str] = None
    date: Optional[date] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    isAgentActingForPublisher: Optional[bool] = None
    type: Optional[ContractType] = None
    subjectType: Optional[ContractSubjectTypeWebApi] = None
    actionType: Optional[MediationActionType] = None
    parentMainContractId: Optional[str] = None
    clientId: Optional[str] = None
    id: Optional[str] = None
    status: Optional[ContractStatus] = None


class FinalContractsViewData(BaseModel):
    class Config:
        extra = Extra.forbid

    crumbs: Optional[List[Crumbs]] = None
    canCreateContract: Optional[bool] = None
    canRegisterContract: Optional[bool] = None
    canEditContract: Optional[bool] = None
    canCreateUploadContractsReport: Optional[bool] = None
    showAgencyColumn: Optional[bool] = None


class GetInvoicesWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    invoiceId: Optional[str] = None
    number: Optional[str] = None
    dateStart: Optional[date] = None
    dateEnd: Optional[date] = None
    finalContractId: Optional[str] = None
    status: Optional[InvoiceStatus] = None


class InitialContractCardDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    agencyId: Optional[str] = None
    clientId: Optional[str] = None
    type: Optional[ContractType] = None
    status: Optional[ContractStatus] = None
    number: Optional[str] = None
    date: Optional[date] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    isAgentActingForPublisher: Optional[bool] = None
    mediationContractSubjectType: Optional[MediationContractSubjectType] = None
    serviceAgreementSubjectType: Optional[ServiceAgreementSubjectType] = None
    otherSubjectValue: Optional[str] = None
    actionType: Optional[MediationActionType] = None
    otherActionValue: Optional[str] = None
    parentMainContractId: Optional[str] = None
    createDt: Optional[datetime] = None
    changeDt: Optional[datetime] = None
    parentMainContract: Optional[ContractCardDto] = None
    isAutoRegister: Optional[bool] = None
    finalContractId: Optional[str] = None


class InitialContractWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    number: Optional[str] = None
    date: Optional[date] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    isAgentActingForPublisher: Optional[bool] = None
    type: Optional[ContractType] = None
    subjectType: Optional[ContractSubjectTypeWebApi] = None
    actionType: Optional[MediationActionType] = None
    parentMainContractId: Optional[str] = None
    contractorId: Optional[str] = None
    clientId: Optional[str] = None
    finalContractId: Optional[str] = None
    id: Optional[str] = None
    status: Optional[ContractStatus] = None
    contractorInn: Optional[str] = None
    contractorName: Optional[str] = None
    clientInn: Optional[str] = None
    clientName: Optional[str] = None


class InitialContractsViewData(BaseModel):
    class Config:
        extra = Extra.forbid

    crumbs: Optional[List[Crumbs]] = None
    canCreateContracts: Optional[bool] = None
    canRegisterContracts: Optional[bool] = None
    canEditContracts: Optional[bool] = None
    canEditInitialContractClient: Optional[bool] = None
    showAgencyColumn: Optional[bool] = None


class InvoiceCardView(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    topLevelAgencyId: Optional[str] = None
    finalContractId: Optional[str] = None
    number: Optional[str] = None
    date: Optional[date] = None
    status: Optional[InvoiceStatus] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    startDate: Optional[date] = None
    endDate: Optional[date] = None
    agencyRole: Optional[InvoicePartyRole] = None
    clientRole: Optional[InvoicePartyRole] = None
    registerDt: Optional[datetime] = None
    createDt: Optional[datetime] = None
    changeDt: Optional[datetime] = None
    invoiceSummary: Optional[InvoiceSummaryDto] = None


class InvoiceStatisticsByPlatformsItemWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    initialContractId: Optional[str] = None
    erid: Optional[str] = None
    platformUrl: Optional[str] = None
    platformName: Optional[str] = None
    platformType: Optional[PlatformType] = None
    platformOwnedByAgency: Optional[bool] = None
    impsPlan: Optional[int] = None
    impsFact: Optional[int] = None
    startDatePlan: Optional[date] = None
    startDateFact: Optional[date] = None
    endDatePlan: Optional[date] = None
    endDateFact: Optional[date] = None
    amount: Optional[float] = None
    price: Optional[float] = None
    vatIncluded: Optional[bool] = None


class InvoiceWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    number: Optional[str] = None
    date: Optional[date] = None
    contractorRole: Optional[InvoicePartyRole] = None
    clientRole: Optional[InvoicePartyRole] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    startDate: Optional[date] = None
    endDate: Optional[date] = None
    finalContractId: Optional[str] = None
    initialContractsData: Optional[List[InvoiceInitialContractItemWebApiDto]] = None
    statisticsByPlatforms: Optional[List[InvoiceStatisticsByPlatformsItemWebApiDto]] = None
    id: Optional[str] = None
    status: Optional[InvoiceStatus] = None


class InvoicesViewData(BaseModel):
    class Config:
        extra = Extra.forbid

    crumbs: Optional[List[Crumbs]] = None
    canCreateInvoice: Optional[bool] = None
    canManualInputInitialContractCosts: Optional[bool] = None
    canRegisterInvoice: Optional[bool] = None
    canEditInvoice: Optional[bool] = None
    canDeleteInvoice: Optional[bool] = None
    canCreateAgencyConsolidatedReport: Optional[bool] = None
    canCreateInvoicesConsolidatedReport: Optional[bool] = None
    showAgencyColumn: Optional[bool] = None
    canBulkUploadInvoices: Optional[bool] = None


class OuterContractCardDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    agencyId: Optional[str] = None
    clientId: Optional[str] = None
    type: Optional[ContractType] = None
    status: Optional[ContractStatus] = None
    number: Optional[str] = None
    date: Optional[date] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    isAgentActingForPublisher: Optional[bool] = None
    mediationContractSubjectType: Optional[MediationContractSubjectType] = None
    serviceAgreementSubjectType: Optional[ServiceAgreementSubjectType] = None
    otherSubjectValue: Optional[str] = None
    actionType: Optional[MediationActionType] = None
    otherActionValue: Optional[str] = None
    parentMainContractId: Optional[str] = None
    createDt: Optional[datetime] = None
    changeDt: Optional[datetime] = None
    parentMainContract: Optional[ContractCardDto] = None
    isAutoRegister: Optional[bool] = None
    isRegReport: Optional[bool] = None


class OuterContractsViewData(BaseModel):
    class Config:
        extra = Extra.forbid

    crumbs: Optional[List[Crumbs]] = None
    canCreateContracts: Optional[bool] = None
    canRegisterContracts: Optional[bool] = None
    canEditContracts: Optional[bool] = None
    showAgencyColumn: Optional[bool] = None


class PlatformCardWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    name: Optional[str] = None
    type: Optional[PlatformType] = None
    url: Optional[str] = None
    isOwner: Optional[bool] = None
    id: Optional[str] = None


class PlatformsViewData(BaseModel):
    class Config:
        extra = Extra.forbid

    crumbs: Optional[List[Crumbs]] = None
    canCreatePlatform: Optional[bool] = None
    canEditPlatform: Optional[bool] = None
    showAgencyColumn: Optional[bool] = None


class RoleDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[UserRole] = None
    description: Optional[str] = None


class SelfPromotionContractCardDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    agencyId: Optional[str] = None
    clientId: Optional[str] = None
    type: Optional[ContractType] = None
    status: Optional[ContractStatus] = None
    number: Optional[str] = None
    date: Optional[date] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    isAgentActingForPublisher: Optional[bool] = None
    mediationContractSubjectType: Optional[MediationContractSubjectType] = None
    serviceAgreementSubjectType: Optional[ServiceAgreementSubjectType] = None
    otherSubjectValue: Optional[str] = None
    actionType: Optional[MediationActionType] = None
    otherActionValue: Optional[str] = None
    parentMainContractId: Optional[str] = None
    createDt: Optional[datetime] = None
    changeDt: Optional[datetime] = None
    parentMainContract: Optional[ContractCardDto] = None
    isAutoRegister: Optional[bool] = None


class SelfPromotionContractsViewData(BaseModel):
    class Config:
        extra = Extra.forbid

    crumbs: Optional[List[Crumbs]] = None
    canCreateContracts: Optional[bool] = None
    canRegisterContracts: Optional[bool] = None
    canEditContracts: Optional[bool] = None
    showAgencyColumn: Optional[bool] = None


class SupplementInvoiceWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    invoiceId: Optional[str] = None
    initialContractsData: Optional[List[InvoiceInitialContractItemWebApiDto]] = None
    statisticsByPlatforms: Optional[List[InvoiceStatisticsByPlatformsItemWebApiDto]] = None


class UserCardDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[int] = None
    login: Optional[str] = None
    email: Optional[str] = None
    phoneNumber: Optional[str] = None
    firstName: Optional[str] = None
    middleName: Optional[str] = None
    lastName: Optional[str] = None
    enabled: Optional[bool] = None
    createDt: Optional[datetime] = None
    updated: Optional[datetime] = None
    password: Optional[str] = None
    salt: Optional[str] = None
    ad: Optional[bool] = None
    isAgencyGroupUser: Optional[bool] = None
    isAgencyGroupAdministrator: Optional[bool] = None
    roles: Optional[List[RoleDto]] = None
    topLevelAgencyId: Optional[str] = None


class AgencyGroupCardDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    contract: Optional[str] = None
    name: Optional[str] = None
    createDt: Optional[datetime] = None
    changeDt: Optional[datetime] = None
    agencies: Optional[List[AgencyCardDto]] = None
    users: Optional[List[AgencyGroupUserCardDto]] = None
    administrators: Optional[List[AgencyGroupUserCardDto]] = None


class ClientsViewData(BaseModel):
    class Config:
        extra = Extra.forbid

    crumbs: Optional[List[Crumbs]] = None
    canCreateClient: Optional[bool] = None
    canRegisterClient: Optional[bool] = None
    canEditClient: Optional[bool] = None
    showAgencyColumn: Optional[bool] = None


class CreateCreativeBulkWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    creatives: Optional[List[CreateDelayedCreativeWebApiDto]] = None


class CreateInvoiceWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    number: Optional[str] = None
    date: Optional[date] = None
    contractorRole: Optional[InvoicePartyRole] = None
    clientRole: Optional[InvoicePartyRole] = None
    amount: Optional[float] = None
    vatIncluded: Optional[bool] = None
    startDate: Optional[date] = None
    endDate: Optional[date] = None
    finalContractId: Optional[str] = None
    initialContractsData: Optional[List[InvoiceInitialContractItemWebApiDto]] = None
    statisticsByPlatforms: Optional[List[InvoiceStatisticsByPlatformsItemWebApiDto]] = None


class CreativesViewData(BaseModel):
    class Config:
        extra = Extra.forbid

    crumbs: Optional[List[Crumbs]] = None
    canCreateCreative: Optional[bool] = None
    canEditCreativeGroups: Optional[bool] = None
    canRegisterCreative: Optional[bool] = None
    showAgencyColumn: Optional[bool] = None
    executorLegalForm: Optional[LegalForm] = None


class DelayedCreativeBatchInfoWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    creatives: Optional[List[DelayedCreativeWebApiDto]] = None


class EditInvoiceStatisticsWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[str] = None
    initialContractsData: Optional[List[InvoiceInitialContractItemWebApiDto]] = None
    statisticsByPlatforms: Optional[List[InvoiceStatisticsByPlatformsItemWebApiDto]] = None


ContractCardDto.update_forward_refs()
